--
-- DoorOpener
--
-- written by fruktor, visit: www.eifok-team.de
-- Edit by }I{EKA special for MTZ-1025

DoorOpener = {};

DoorOpener.modDir = g_currentModDirectory;

function DoorOpener.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Motorized, specializations);
end;

function DoorOpener:load(savegame)

--  start motor	
	self.playerCallbackStartMotor = SpecializationUtil.callSpecializationsFunction("playerCallbackStartMotor"); 
	
	self.puskMotor = {};
	
	local trigger = Utils.indexToObject( self.components, getXMLString(self.xmlFile, string.format("vehicle.StartMotor#trigger")) );
	if trigger == nil then
		print("[Error::StartMotor] node is OK, but trigger could not be located. Check line "..tostring(i+1).." in your vehicle.xml");
	end;
	
	self.puskMotor.trigger = trigger;
	self.puskMotor.plIR = false;
		
	addTrigger( trigger, "playerCallbackStartMotor", self );
end;

function DoorOpener:delete()
--  start motor	
	if self.puskMotor.trigger ~= nil then
		removeTrigger(self.puskMotor.trigger);
	end;
end;

function DoorOpener:readStream(streamId, connection)
end;

function DoorOpener:writeStream(streamId, connection)
end;

function DoorOpener:mouseEvent(posX, posY, isDown, isUp, button)
end;

function DoorOpener:keyEvent(unicode, sym, modifier, isDown)
end;

function DoorOpener:update(dt)
	if self.puskMotor.plIR then
		g_currentMission:addHelpButtonText( g_i18n:getText("StartMotor"), InputBinding.TOGGLE_MOTOR_STATE );	
		setTextColor(1.0, 1.0, 1.0, 1.0);
		setTextAlignment(RenderText.ALIGN_LEFT); 				
		renderText( 0.5, 0.06, 0.02, g_i18n:getText("StartMotor") );
        if self.isClient then
            if InputBinding.hasEvent(InputBinding.TOGGLE_MOTOR_STATE) then
                        if self.isMotorStarted then
                            self:stopMotor()
                        else
                            self:startMotor()
                        end
            end
        end
	end;
end;

function DoorOpener:onLeave()
end;

function DoorOpener:draw()
end;


function DoorOpener:playerCallbackStartMotor(triggerId, otherId, onEnter, onLeave, onStay)
	if onEnter and g_currentMission.controlPlayer and g_currentMission.player ~= nil and otherId == g_currentMission.player.rootNode then
		self.puskMotor.plIR = true;
	elseif onLeave and g_currentMission.player ~= nil and otherId == g_currentMission.player.rootNode then
		self.puskMotor.plIR = false;
	end;
end;
